#!/usr/bin/php -q
<?

# _________________________________________________________________________
# globales

error_reporting( E_PARSE | E_CORE_ERROR | E_ERROR );
set_time_limit( 0 );


// User => Password
// TODO: fill in your usernames and passwords
$userliste = array( "user1" => "pw1", "user2" => "pw2", "user3" => "pw3" );


# _________________________________________________________________________

# we read from stdin:

$inhand = fopen( "php://stdin", 'r' );


# _________________________________________________________________________
# funktionen



function logger( $txt )
{
	openlog( "Bookmark-Backend", LOG_PID, LOG_DAEMON );
	syslog( LOG_INFO, $txt );
	closelog();
}




function lesen()
{
	global $inhand;
	$s = fgets( $inhand, 1024 );
	if( substr( $s, -1 ) == "\n" )
		$s = substr( $s, 0, -1 );
	return( $s );
}


function raus( $s )
{
	logger( "raus(" . $s . ")" );
	if( substr( $s, -1 ) == "\n" )
		print( $s );
	else
		print( "$s\n" );
	flush();
}




# _________________________________________________________________________
# START

	raus( "bookmark ok" );
	$logout = true;
	$modifiziert = false;
	do
	{
		$zeile = lesen(); // from tanne
		logger( "Befehl '$zeile'" );
		if( $zeile == "timeout" )
			exit();
		list( $bef, $parameter ) = split( ' ', $zeile, 2 );
		$ende = false;
		if( $bef == "" )
			$ende = true;
		else
			raus( "OK" );

		while(( $zeile = lesen()) != "OK" )
		{
			if( is_int( strpos( $zeile, "=" )))
			{
				list( $k, $v ) = explode( '=', $zeile, 2 );
				if( $v > 0 )
					$v = fread( $inhand, $v );
				else
					$v = "";
				$v = str_replace( "\r", "", $v );	
				$felder[$k] = $v;
				logger( "felder[$k] = '$v'" );
			}
		}

		$h = false;
		switch( $bef )
		{
			case 'neu':
				if( !$logout && $felder["neulink"] > "" )
				{
					$linkliste[] = $felder["neulink"];
					$modifiziert = true;
				}
				break;
			case 'weg':
				if( !$logout )
				{
					$linkliste[$parameter] = "";
					$modifiziert = true;
				}
				break;
			case 'login':
				if( $felder["user"] > "" && $userliste[$felder["user"]] > "" && $userliste[$felder["user"]] == $felder["pw"] )
				{
					$linkliste = array();
					if(( $h = fopen( $felder["user"], 'r' )) != false )
					{
						while( !feof( $h ))
							$linkliste[] = trim( fgets( $h, 2048 ));
						fclose( $h );
					}
					$seite = "liste";
					$logout = false;
					break;
				}
			default:
				$seite = "login";
				$logout = true;
				break;
		}

		raus( $seite );
		reset( $linkliste );
		while(( $zeile = lesen()) != "ende" )
		{
			list( $k, $v ) = explode( ':', $zeile, 2 );
			switch( $k )
			{
				case 'usr':
					raus( $felder["user"] );
					break;
				case 'bef':
					raus( "|$v" );
					break;
				case 'lnk':
					do
					{
						if( !( list( $k, $v ) = each( $linkliste )))
						{
							raus( "" );
							break 2;
						}
					}
					while( $v == "" );
					raus( $k );
					raus( $v );
					break;
			}
		}
		if( $h != false )
			fclose( $h );
	}
	while( $logout == false );

	if( $modifiziert )
	{
		umask( 0077 );
		$h = fopen( $felder["user"], 'w' );
		if( $h != false )
		{
			reset( $linkliste );
			while( list( $k, $v ) = each( $linkliste ))
			{
				if( $v > "" )
					fwrite( $h, "$v\n" );
			}
			fclose( $h );
		}
	}


?>

